#
# Spec file for oracleasm
#

# Macros
# This one is hardcoded because, well, it belongs there
%define _prefix /usr
# Because RPM is dumb
%define _unpackaged_files_terminate_build 0

# Turn on's and off's (summit and debug not used but added
# for future proofing)
%define buildup		1
%define buildsmp	1
%define buildhugemem	1
%define builddebug	0

# From the EL3 kernel specfile
%ifnarch i686
%define buildhugemem 0
%endif

%ifarch s390 s390x
%define buildsmp	0
%endif
%ifarch ppc64pseries ppc64iseries
%define buildsmp	0
%endif
%ifarch ia64
%define buildsmp	0
%endif
%ifarch ia32e
%define buildsmp	0
%endif


# This must be changed to the minimum ABI compat kernel version expected
%define base 2.4.21
%define sver	 60.0.0.0.1
%define kver %{base}-%{sver}.EL

# The minimum -support package required for the kernel bits.
%define support_ver     2.0.0

Summary: The Oracle Automatic Storage Management library driver.
Name: oracleasm-%{kver}
Version: 1.0.5
Release: 1
Copyright: GPL
Group: System Environment/Kernel
Source: oracleasm-1.0.5.tar.gz
URL: http://oss.oracle.com/
Distribution: Oracle
Vendor: Oracle Corporation
Packager: Joel Becker <joel.becker@oracle.com>
Provides: oracleasm = %{version}
AutoReqProv: no
Requires: kernel = %{kver}
Requires: oracleasm-support >= %{support_ver}
BuildRequires: kernel-source = %{kver}


BuildRoot: %{_tmppath}/oracleasm-%{PACKAGE_VERSION}-%{PACKAGE_RELEASE}-root


%description
Kernel driver for the Oracle Automatic Storage Management library.
This package is compiled for uniprocessor kernels.

%if %{buildsmp}
%package -n oracleasm-%{kver}smp
Summary: The Oracle Automatic Storage Management library driver for SMP systems.
Group: System Environment/Kernel
Provides: oracleasm = %{version}
Requires: kernel-smp = %{kver}
Requires: oracleasm-support >= %{support_ver}
BuildRequires: kernel-source = %{kver}
AutoReqProv: no


%description -n oracleasm-%{kver}smp
Kernel driver for the Oracle Automatic Storage Management library.
This package is compiled for symmetric multiprocessor kernels.
%endif


%if %{buildhugemem}
%package -n oracleasm-%{kver}hugemem
Summary: The Oracle Automatic Storage Management library driver for hugemem systems.
Group: System Environment/Kernel
Provides: oracleasm = %{version}
Requires: kernel-hugemem = %{kver}
Requires: oracleasm-support >= %{support_ver}
BuildRequires: kernel-source = %{kver}
AutoReqProv: no


%description -n oracleasm-%{kver}hugemem
Kernel driver for the Oracle Automatic Storage Management library.
This package is compiled for symmetric multiprocessor kernels on
machines with more than 16GB of RAM.
%endif


%if %{builddebug}
%package -n oracleasm-%{kver}debug
Summary: The Oracle Automatic Storage Management library driver for debugging systems.
Group: System Environment/Kernel
Provides: oracleasm = %{version}
Requires: kernel-debug = %{kver}
Requires: oracleasm-support >= %{support_ver}
BuildRequires: kernel-source = %{kver}
AutoReqProv: no


%description -n oracleasm-%{kver}debug
Kenrel driver for the Oracle Automatic Storage Management library.
This package is compiled for debugging kernels.
%endif




%prep
%setup -n oracleasm-%{version}


%build
# Hack to find a good source tree
KPATH="/usr/src/linux-%{kver}"
%configure --sbindir=/usr/sbin --with-kernel="${KPATH}"
cd kernel

%if %{buildup}
make KVER=up
make DESTDIR="$RPM_BUILD_ROOT" MODULEDIR="/lib/modules/%{kver}/kernel/drivers/addon/oracleasm" install 
%endif

%if %{buildsmp}
make clean
make KVER=smp
make DESTDIR="$RPM_BUILD_ROOT" MODULEDIR="/lib/modules/%{kver}smp/kernel/drivers/addon/oracleasm" install 
%endif

%if %{buildhugemem}
make clean
make KVER=hugemem
make DESTDIR="$RPM_BUILD_ROOT" MODULEDIR="/lib/modules/%{kver}hugemem/kernel/drivers/addon/oracleasm" install 
%endif

%if %{builddebug}
make clean
make KVER=debug
make DESTDIR="$RPM_BUILD_ROOT" MODULEDIR="/lib/modules/%{kver}debug/kernel/drivers/addon/oracleasm" install 
%endif



%install



%clean
rm -rf "$RPM_BUILD_ROOT"



%if %{buildup}
%post
depmod -ae %{kver}

%files
%defattr(-,root,root)
/lib/modules/%{kver}/kernel/drivers/addon/oracleasm
%endif

%if %{buildsmp}
%post -n oracleasm-%{kver}smp
depmod -ae %{kver}smp

%files -n oracleasm-%{kver}smp
%defattr(-,root,root)
/lib/modules/%{kver}smp/kernel/drivers/addon/oracleasm
%endif

%if %{buildhugemem}
%post -n oracleasm-%{kver}hugemem
depmod -ae %{kver}hugemem

%files -n oracleasm-%{kver}hugemem
%defattr(-,root,root)
/lib/modules/%{kver}hugemem/kernel/drivers/addon/oracleasm
%endif

%if %{builddebug}
%post -n oracleasm-%{kver}debug
depmod -ae %{kver}debug

%files -n oracleasm-%{kver}debug
%defattr(-,root,root)
/lib/modules/%{kver}debug/kernel/drivers/addon/oracleasm
%endif



%changelog
* Mon Jan 31 2005 Joel Becker <joel.becker@oracle.com>
- Make ABI-sepecific

* Tue Jan 13 2004 Joel Becker <joel.becker@oracle.com>
- Kernel-only EL3 specfile.

* Wed Nov 12 2003 Joel Becker <joel.becker@oracle.com>
- Start the ASM rename.

* Thu Oct 30 2003 Joel Becker <joel.becker@oracle.com>
- Created EL3 version

* Mon Jun 23 2003 Joel Becker <joel.becker@oracle.com>
- Added osm-lib bits

* Fri Jun 20 2003 Joel Becker <joel.becker@oracle.com>
- Initial RPM

